Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.appengine.api.datastore
Class FetchOptions

    java.lang.Object
      com.google.appengine.api.datastore.FetchOptions

    public final class FetchOptions

extends java.lang.Object

Describes the limit, offset, and chunk size to be applied when executing a `PreparedQuery`.

`limit` is the maximum number of results the query will return.

`offset` is the number of result to skip before returning any results. Results that are skipped due to offset do not count against `limit`.

`chunkSize` determines the internal chunking strategy of the `Iterator` returned by `PreparedQuery.asIterator(FetchOptions)` and the `Iterable` returned by `PreparedQuery.asIterable(FetchOptions)`. Note that unlike `limit` and `offset`, `chunkSize` has no impact on the result of the `PreparedQuery`, but rather only the performance of the `PreparedQuery`.

Notes on usage:
The recommended way to instantiate a `FetchOptions` object is to statically import `FetchOptions.Builder`.* and invoke a static creation method followed by an instance mutator (if needed):

>      import static com.google.appengine.api.datastore.FetchOptions.Builder.*;

>      ...

>      // limit 10
>      datastoreService.prepare(query).asList(withLimit(10));

>      // limit 10, offset 5
>      datastoreService.prepare(query).asList(withLimit(10).offset(5));

Nested Class Summary
`static class` | `FetchOptions.Builder` Contains static creation methods for `FetchOptions`.

Field Summary
`static int` | `DEFAULT_CHUNK_SIZE` Default number of `Entity` objects to retrieve at a time.

Method Summary
`FetchOptions` | `chunkSize(int chunkSize)` Sets the chunk size.
`FetchOptions` | `limit(int limit)` Sets the limit.
`FetchOptions` | `offset(int offset)` Sets the offset.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_CHUNK_SIZE

    public static final int DEFAULT_CHUNK_SIZE

  Default number of `Entity` objects to retrieve at a time. This is an optimization that avoids making an RPC call for each `Entity`.

  See Also:
    Constant Field Values

Method Detail

### limit

    public FetchOptions limit(int limit)

  Sets the limit. Please read the class javadoc for an explanation of how limit is used.

  Parameters:
    `limit` - The limit to set. Must be greater than 0.
  Returns:
    `this` (for chaining)

### offset

    public FetchOptions offset(int offset)

  Sets the offset. Please read the class javadoc for an explanation of how offset is used.

  Parameters:
    `offset` - The offset to set. Must be 0 or greater.
  Returns:
    `this` (for chaining)

### chunkSize

    public FetchOptions chunkSize(int chunkSize)

  Sets the chunk size. Please read the class javadoc for an explanation of how chunk size is used.

  Parameters:
    `chunkSize` - The chunk size to set. Must be greater than 0.
  Returns:
    `this` (for chaining)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD